> For the complete documentation index, see [llms.txt](https://docs.optitrack.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.optitrack.com/v1.1/developer-tools/motive-api/class-cttapilistener.md).

# Class: cTTAPIListener

When using the Motive API, you can attach or detach cTTAPIListener class to a project by using the following functions.

* TT\_AttachListener
* TT\_DetachListener

### Member Functions

#### TTAPIFrameAvailable

TTAPIFrameAvailable callback is called when a new synchronized group of camera frames has been delivered to the TTAPI and is ready for processing. You can use this notification to then call TT\_Update() without having to poll blindly for new data.

#### InitialPointCloud

InitialPointCloud is called when the initial point cloud is calculated from the connected cameras. During this callback 3D markers can be added (up to MaxMarkers) or removed by modifying the Markers list as well as the MarkerCount variable. After this callback the marker list is passed onto the rigid body solver.

### Declaration: cTTAPIListener

{% code overflow="wrap" %}

```
class TTAPI cTTAPIListener
{
public:
    cTTAPIListener();
    virtual ~cTTAPIListener();

    //== TTAPIFrameAvailable callback is called when a new synchronized group of camera frames has been delivered
    //== to the TTAPI and is ready for processing.  You can use this notification to then call TT_Update() without
    //== having to poll blindly for new data.

    virtual void TTAPIFrameAvailable();

    //== InitialPointCloud is called when the initial point cloud is calculated from the connected cameras. During
    //== this callback 3D markers can be added (up to MaxMarkers) or removed by modifying the Markers list as well
    //== as the MarkerCount variable.  After this callback the marker list is passed onto the rigid body solver.

    virtual void InitialPointCloud(Core::cMarker* markers, int &markerCount, int maxMarkers);
};
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.optitrack.com/v1.1/developer-tools/motive-api/class-cttapilistener.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
